# Create a gift

> For the complete machine-readable documentation index, see [llms.txt](https://apidocs.chargebee.com/llms.txt).


[Idempotency Supported](/docs/api/v2/pcv-1/idempotency)

**Note:** This operation optionally supports 3DS verification flow. To achieve the same, create the [Payment Intent](/docs/api/getting-started) and pass it as input parameter to this API.

Creates a gift subscription with the gifter and receiver. Only plans marked as gift plans can be used to create gift subscription. It may also have addons and coupons. A gift is initially created in '**scheduled**' state and the gift subscription will be created in '**future**' state and invoiced immediately.

Term start and term end dates are determined based on whether the gift is claimed. Before claim, term start date is the subscription start date. Term end date occurs at the end of the plan's frequency. Once the gift is claimed, the gift claim date becomes the term start date and the term end date will be set as the end of the plan's frequency.

## Sample Request

#### cURL

```bash
curl  https://{site}.chargebee.com/api/v2/gifts \
     -u {site_api_key}:\
     -d scheduled_at=1518106289 \
     -d "subscription[plan_id]"="GiftPlan$100" \
     -d "gifter[customer_id]"="gifter" \
     -d "gifter[signature]"="Sam" \
     -d "gift_receiver[customer_id]"="receiver" \
     -d "gift_receiver[first_name]"="James" \
     -d "gift_receiver[last_name]"="William" \
     -d "gift_receiver[email]"="james@user.com"
```

#### .NET

```dotnet
using ChargeBee.Api;
using ChargeBee.Models;

ApiConfig.Configure("{site}","{site_api_key}");
EntityResult result = Gift.Create()
		.ScheduledAt(1518106289)
		.SubscriptionPlanId("GiftPlan$100")
		.GifterCustomerId("gifter")
		.GifterSignature("Sam")
		.GiftReceiverCustomerId("receiver")
		.GiftReceiverFirstName("James")
		.GiftReceiverLastName("William")
		.GiftReceiverEmail("james@user.com")
		.Request();

Gift gift = result.Gift;
Subscription subscription = result.Subscription;
Invoice invoice = result.Invoice;
```

#### Go

```go
package main
import (
    "fmt"
    "github.com/chargebee/chargebee-go/v3"
    giftAction "github.com/chargebee/chargebee-go/v3/actions/gift"
    "github.com/chargebee/chargebee-go/v3/models/gift"
)
func main() {
    chargebee.Configure("{site_api_key}","{site}");
    res,err := giftAction.Create(&gift.CreateRequestParams{
        ScheduledAt : chargebee.Int64(1518106289),
        Subscription : &gift.CreateSubscriptionParams{
            PlanId : "GiftPlan$100",
        },
        Gifter : &gift.CreateGifterParams{
            CustomerId : "gifter",
            Signature : "Sam",
        },
        GiftReceiver : &gift.CreateGiftReceiverParams{
            CustomerId : "receiver",
            FirstName : "James",
            LastName : "William",
            Email : "james@user.com",
        },
    }).Request()
    if err != nil {
        fmt.Println(err)
    } else {
        Gift := res.Gift
        Subscription := res.Subscription
        Invoice := res.Invoice
    }
}
```

#### Go

```go
package main

import (
  "fmt"
  "github.com/chargebee/chargebee-go/v4"
)

func main() {
  config := &chargebee.ClientConfig{
    SiteName: "{site}",
    ApiKey: "{site_api_key}",
  }    
  client := chargebee.NewClient(config)
  req := &chargebee.GiftCreateRequest{
    ScheduledAt : chargebee.Int64(1518106289),
    Subscription : &chargebee.GiftCreateSubscription{
        PlanId : "GiftPlan$100",
    },
    Gifter : &chargebee.GiftCreateGifter{
        CustomerId : "gifter",
        Signature : "Sam",
    },
    GiftReceiver : &chargebee.GiftCreateGiftReceiver{
        CustomerId : "receiver",
        FirstName : "James",
        LastName : "William",
        Email : "james@user.com",
    },
}
  res, err := client.Gift.Create(req)
      if err != nil {
        fmt.Println(err)
    } else {
        Gift := res.Gift
        Subscription := res.Subscription
        Invoice := res.Invoice
    }
}
```

#### Java

```java
import com.chargebee.*;
import com.chargebee.ListResult;
import com.chargebee.models.*;
import com.chargebee.models.enums.*;
import java.io.IOException;
import java.sql.Timestamp;

public class Sample {

    public static void main(String args[]) throws IOException, Exception {
        Environment.configure("{site}", "{site_api_key}");
        Result result = Gift.create()
            .scheduledAt(new Timestamp(1518106289L * 1000))
            .subscriptionPlanId("GiftPlan$100")
            .gifterCustomerId("gifter")
            .gifterSignature("Sam")
            .giftReceiverCustomerId("receiver")
            .giftReceiverFirstName("James")
            .giftReceiverLastName("William")
            .giftReceiverEmail("james@user.com")
            .request();

        Gift gift = result.gift();
        Subscription subscription = result.subscription();
        Invoice invoice = result.invoice();
    }
}
```

#### Java

```java
import com.chargebee.v4.client.ChargebeeClient;
import com.chargebee.v4.models.gift.Gift;
import com.chargebee.v4.models.gift.params.GiftCreateParams;
import com.chargebee.v4.models.gift.responses.GiftCreateResponse;
import com.chargebee.v4.models.invoice.Invoice;
import com.chargebee.v4.models.subscription.Subscription;
import java.sql.Timestamp;

public class GiftCreate {

    public static void main(String[] args) {
        ChargebeeClient client = ChargebeeClient.builder()
            .apiKey("{site_api_key}")
            .siteName("{site}")
            .build();

        GiftCreateParams.SubscriptionParams subscriptionParams =
            GiftCreateParams.SubscriptionParams.builder()
                .planId("GiftPlan$100")
                .build();

        GiftCreateParams.GifterParams gifterParams =
            GiftCreateParams.GifterParams.builder()
                .customerId("gifter")
                .signature("Sam")
                .build();

        GiftCreateParams.GiftReceiverParams giftReceiverParams =
            GiftCreateParams.GiftReceiverParams.builder()
                .customerId("receiver")
                .firstName("James")
                .lastName("William")
                .email("james@user.com")
                .build();

        GiftCreateParams params = GiftCreateParams.builder()
            .scheduledAt(new Timestamp(1518106289L * 1000))
            .subscription(subscriptionParams)
            .gifter(gifterParams)
            .giftReceiver(giftReceiverParams)
            .build();

        GiftCreateResponse response = client.gifts().create(params);

        Gift gift = response.getGift();
        Subscription subscription = response.getSubscription();
        Invoice invoice = response.getInvoice();
    }
}
```

#### Node.js

```node
import Chargebee from "chargebee";

const chargebee = new Chargebee({
    site: "{site}",
    apiKey: "{site_api_key}",
});

try {
    const result = await chargebee.gift.create({
        scheduled_at: 1518106289,
        subscription: {
            plan_id: "GiftPlan$100"
        },
        gifter: {
            customer_id: "gifter",
            signature: "Sam"
        },
        gift_receiver: {
            customer_id: "receiver",
            first_name: "James",
            last_name: "William",
            email: "james@user.com"
        }
    });

    console.log(result);
    const gift = result.gift;
    const subscription = result.subscription;
    const invoice = result.invoice;
} catch (err) {
    console.log(err);
}
```

#### PHP

```php
<?php

require __DIR__ . '/vendor/autoload.php';

use Chargebee\ChargebeeClient;

$chargebee = new ChargebeeClient(options: [
    "site" => "{site}",
    "apiKey" => "{site_api_key}",
]);
$result = $chargebee->gift()->create([
    "scheduled_at" => 1518106289,
    "subscription" => [
        "plan_id" => "GiftPlan$100"
    ],
    "gifter" => [
        "customer_id" => "gifter",
        "signature" => "Sam"
    ],
    "gift_receiver" => [
        "customer_id" => "receiver",
        "first_name" => "James",
        "last_name" => "William",
        "email" => "james@user.com"
    ]
]);
$gift = $result->gift;
$subscription = $result->subscription;
$invoice = $result->invoice;
```

#### Python

```python
from chargebee import Chargebee

cb_client = Chargebee(api_key="{site_api_key}", site="{site}")
response = cb_client.Gift.create(
    cb_client.Gift.CreateParams(
        scheduled_at=1518106289,
        subscription=cb_client.Gift.CreateSubscriptionParams(
            plan_id="GiftPlan$100"
        ),
        gifter=cb_client.Gift.CreateGifterParams(
            customer_id="gifter",
            signature="Sam"
        ),
        gift_receiver=cb_client.Gift.CreateGiftReceiverParams(
            customer_id="receiver",
            first_name="James",
            last_name="William",
            email="james@user.com"
        )
    )
)
gift = response.gift
subscription = response.subscription
invoice = response.invoice
```

#### Ruby

```ruby
require 'chargebee'

ChargeBee.configure(:site => "{site}",
  :api_key => "{site_api_key}")

result = ChargeBee::Gift.create({
  :scheduled_at => 1518106289,
  :subscription => {
    :plan_id => "GiftPlan$100"
  },
  :gifter => {
    :customer_id => "gifter",
    :signature => "Sam"
  },
  :gift_receiver => {
    :customer_id => "receiver",
    :first_name => "James",
    :last_name => "William",
    :email => "james@user.com"
  }
})

gift = result.gift
subscription = result.subscription
invoice = result.invoice
```

## Sample Response

```json
{
  "gift": {
    "auto_claim": false,
    "claim_expiry_date": 1525882289,
    "gift_receiver": {
      "customer_id": "receiver",
      "email": "james@user.com",
      "first_name": "James",
      "last_name": "William",
      "object": "gift_receiver",
      "subscription_id": "__test__KyVnHhSBWTKIb9W"
    },
    "gift_timelines": [
      {
        "object": "gift_timeline",
        "occurred_at": 1517501490,
        "status": "scheduled"
      },
      {..}
    ],
    "gifter": {
      "customer_id": "gifter",
      "invoice_id": "__demo_inv__3",
      "object": "gifter",
      "signature": "Sam"
    },
    "id": "__test__KyVnHhSBWTKOI9c__test__Dt9bqgOT98zHf6Dwo9mcdylaNXklOjAlr",
    "no_expiry": false,
    "object": "gift",
    "resource_version": 1517501490000,
    "scheduled_at": 1518106289,
    "status": "scheduled",
    "updated_at": 1517501490
  },
  "invoice": {
    "adjustment_credit_notes": {},
    "amount_adjusted": 0,
    "amount_due": 0,
    "amount_paid": 10000,
    "amount_to_collect": 0,
    "applied_credits": {},
    "base_currency_code": "USD",
    "billing_address": {
      "first_name": "John",
      "last_name": "Doe",
      "object": "billing_address",
      "validation_status": "not_validated"
    },
    "credits_applied": 0,
    "currency_code": "USD",
    "customer_id": "gifter",
    "date": 1517501489,
    "deleted": false,
    "due_date": 1517501489,
    "dunning_attempts": {},
    "exchange_rate": 1,
    "first_invoice": true,
    "has_advance_charges": true,
    "id": "__demo_inv__3",
    "is_gifted": true,
    "issued_credit_notes": {},
    "line_items": [
      {
        "amount": 10000,
        "customer_id": "receiver",
        "date_from": 1612800689,
        "date_to": 1615219889,
        "description": "New Year Gift",
        "discount_amount": 0,
        "entity_id": "GiftPlan$100",
        "entity_type": "plan",
        "id": "li___test__KyVnHhSBWTKJZ9Y",
        "is_taxed": false,
        "item_level_discount_amount": 0,
        "object": "line_item",
        "pricing_model": "flat_fee",
        "quantity": 1,
        "subscription_id": "__test__KyVnHhSBWTKIb9W",
        "tax_amount": 0,
        "tax_exempt_reason": "tax_not_configured",
        "unit_amount": 10000
      },
      {..}
    ],
    "linked_orders": {},
    "linked_payments": [
      {
        "applied_amount": 10000,
        "applied_at": 1517501489,
        "txn_amount": 10000,
        "txn_date": 1517501489,
        "txn_id": "txn___test__KyVnHhSBWTKKO9Z",
        "txn_status": "success"
      },
      {..}
    ],
    "net_term_days": 0,
    "new_sales_amount": 10000,
    "object": "invoice",
    "paid_at": 1517501489,
    "price_type": "tax_exclusive",
    "recurring": true,
    "resource_version": 1517501489000,
    "round_off_amount": 0,
    "status": "paid",
    "sub_total": 10000,
    "tax": 0,
    "term_finalized": false,
    "total": 10000,
    "updated_at": 1517501489,
    "write_off_amount": 0
  },
  "subscription": {
    "billing_period": 1,
    "billing_period_unit": "month",
    "created_at": 1517501489,
    "currency_code": "USD",
    "customer_id": "receiver",
    "deleted": false,
    "due_invoices_count": 0,
    "gift_id": "__test__KyVnHhSBWTKOI9c__test__Dt9bqgOT98zHf6Dwo9mcdylaNXklOjAlr",
    "has_scheduled_changes": false,
    "id": "__test__KyVnHhSBWTKIb9W",
    "next_billing_at": 1615219889,
    "object": "subscription",
    "plan_amount": 10000,
    "plan_free_quantity": 0,
    "plan_id": "GiftPlan$100",
    "plan_quantity": 1,
    "plan_unit_price": 10000,
    "remaining_billing_cycles": 1,
    "resource_version": 1517501490000,
    "start_date": 1612800689,
    "status": "future",
    "updated_at": 1517501490
  }
}
```

## URL Format

**POST** https://[site].chargebee.com/api/v2/gifts

## Input Parameters

- `scheduled_at` (optional, timestamp(UTC) in seconds)
  Indicates the date on which the gift notification is sent to the receiver. If not passed, the receiver is notified immediately.

- `auto_claim` (optional, boolean, default=false)
  When `true` , the claim happens automatically. When not passed, the default value in the site settings is used.

- `no_expiry` (optional, boolean)
  When `true` , indicates that the gift does not expire. Do not pass or pass as `false` when `auto_claim` is set. .

- `claim_expiry_date` (optional, timestamp(UTC) in seconds)
  The date until which the gift can be claimed. Must be set to a value after `scheduled_at`. If the gift is not claimed within `claim_expiry_date` , it will expire and the subscription will move to `cancelled` state. When not passed, the value specified in the site settings will be used. Pass as `NULL` or do not pass when `auto_claim` or `no_expiry` are set.

- `coupon_ids` (optional, string, max chars=100)
  List of coupons to be applied to this subscription. You can provide coupon ids or coupon codes.

- `gifter` (optional, string)
  Parameters for gifter
  - `customer_id` (required, string, max chars=50)
    Gifter customer id.
  - `signature` (required, string, max chars=50)
    Gifter sign-off name
  - `note` (optional, string, max chars=500)
    Personalized message for the gift.
  - `payment_src_id` (optional, string, max chars=40)
    Identifier of the payment source

- `gift_receiver` (optional, string)
  Parameters for gift\_receiver
  - `customer_id` (required, string, max chars=50)
    Receiver customer id.
  - `first_name` (required, string, max chars=150)
    First name of the receiver as given by the gifter.
  - `last_name` (required, string, max chars=150)
    Last name of the receiver as given by the gifter,
  - `email` (required, string, max chars=70)
    Email of the receiver. All gift related emails are sent to this email.

- `payment_intent` (optional, string)
  Parameters for payment\_intent
  - `id` (optional, string, max chars=150)
    Identifier for PaymentIntent generated by Chargebee.js. Applicable only when you are using Chargebee.js for completing the 3DS flow. The PaymentIntent should be in 'authorized' state while passing it here. You need not pass other PaymentIntent parameters if this is passed.
  - `gateway_account_id` (required if payment intent token provided, string, max chars=50)
    The gateway account used for performing the 3DS flow.
  - `gw_token` (optional, string, max chars=65k)
    Identifier for 3DS transaction/verification object at the gateway. Can be passed only after successfully completing the 3DS flow. Refer [3DS implementation in Chargebee](/docs/api/3ds_card_payments) to find out the gateway-specific gw\_token format. Applicable when you are using gateway APIs directly for completing the 3DS flow.
  - `payment_method_type` (optional, enumerated string)
    The list of payment method types (For example, card, ideal, sofort, bancontact, etc.) this Payment Intent is allowed to use. If payment method type is empty, Card is taken as the default type for all gateways except Razorpay.
    Possible enum values:
      - `card`
        card
      - `ideal`
        ideal
      - `sofort`
        sofort
      - `bancontact`
        bancontact
      - `google_pay`
        google\_pay
      - `dotpay`
        dotpay
      - `giropay`
        giropay
      - `apple_pay`
        apple\_pay
      - `upi`
        upi
      - `netbanking_emandates`
        netbanking\_emandates
      - `paypal_express_checkout`
        paypal\_express\_checkout
      - `direct_debit`
        direct\_debit
      - `boleto`
        boleto
      - `venmo`
        Venmo
      - `amazon_payments`
        Amazon Payments
      - `pay_to`
        PayTo
      - `faster_payments`
        Faster Payments
      - `sepa_instant_transfer`
        Sepa Instant Transfer
      - `klarna_pay_now`
        Klarna Pay Now
      - `online_banking_poland`
        Online Banking Poland
      - `payconiq_by_bancontact`
        Payments made via Payconiq by Bancontact.
      - `electronic_payment_standard`
        Electronic Payment Standard
      - `kbc_payment_button`
        KBC Payment Button
      - `pay_by_bank`
        Pay By Bank
      - `trustly`
        Trustly
      - `stablecoin`
        Payments made via Stablecoin.
      - `kakao_pay`
        Payments made via Kakao Pay.
      - `naver_pay`
        Payments made via Naver Pay.
      - `revolut_pay`
        Payments made via Revolut Pay.
      - `cash_app_pay`
        Payments made via Cash App Pay.
      - `wechat_pay`
        Payments made via WeChat Pay.
      - `alipay`
        Payments made via Alipay.
      - `twint`
        Payments made via Twint
      - `go_pay`
        Payments made via GoPay
      - `grab_pay`
        Payments made via GrabPay
      - `pay_co`
        Payments made via PayCo
      - `after_pay`
        Payments made via Afterpay
      - `swish`
        Payments made via Swish
      - `payme`
        Payments made via PayMe
      - `pix`
        Pix
      - `klarna`
        Payments made via Klarna.
      - `alipay_hk`
        Payments made via Alipay HK.
      - `paypay`
        PayPay
      - `gcash`
        Payments made via GCash.
      - `south_korean_cards`
        Payments made via South Korean Cards
      - `paynow`
      - `bizum`
      - `promptpay`
      - `dana`
        Payments made via Dana.
      - `touch_n_go`
        Payments made via Touch 'n Go.
      - `tamara`
        Payments made via Tamara.
      - `qpay`
        Payments made via Qpay.
      - `ovo`
      - `momo`
      - `mercado_pago`
      - `nequi`
      - `nupay`
      - `picpay`
      - `thai_qr`
      - `blik`
      - `fpx`
      - `wero`
      - `p24`
      - `affirm_pay`
      - `rakuten_pay`
  - `reference_id` (optional, string, max chars=65k)
    Identifier for Braintree permanent token. Applicable when you are using Braintree APIs for completing the 3DS flow.
  - `additional_information` (optional, jsonobject)
    -   `checkout_com`: While adding a new payment method using [permanent token](/docs/api/payment_sources/create-using-permanent-token) or passing raw card details to Checkout.com, `document` ID and `country_of_residence` are required to support payments through [dLocal](https://www.checkout.com/docs/previous/payments/payment-methods/cards/dlocal).
        
        -   `payer`: User related information.
            -   `country_of_residence`: This is required since the billing country associated with the user's payment method may not be the same as their country of residence. Hence the user's country of residence needs to be specified. The country code should be a [two-character ISO code](https://docs.checkout.com/resources/codes/country-codes).
            -   `document`: Document ID is the user's [identification number](https://docs.dlocal.com/api-documentation/payins-api-reference/country-reference#documents) based on their country.
    -   `bluesnap`: While passing raw card details to BlueSnap, if `fraud_session_id` is added, [additional validation](https://developers.bluesnap.com/docs/fraud-prevention) is performed to avoid fraudulent transactions.
        
        -   `fraud`: Fraud identification related information.
            -   `fraud_session_id`: Your [BlueSnap fraud session ID](https://developers.bluesnap.com/docs/fraud-prevention#section-implementing-device-data-collector) required to perform anti-fraud validation.
    -   `braintree`: While passing raw card details to Braintree, your `fraud_merchant_id` and the user's `device_session_id` can be added to perform [additional validation](https://developers.braintreepayments.com/guides/premium-fraud-management-tools/device-data-collection/javascript/v3#collecting-device-data) and avoid fraudulent transactions.
        
        -   `fraud`: Fraud identification related information.
            -   `device_session_id`: Session ID associated with the user's device.
            -   `fraud_merchant_id`: Your [merchant ID](https://developers.braintreepayments.com/guides/premium-fraud-management-tools/device-data-collection/javascript/v3#collecting-device-data) for fraud detection.
    -   `chargebee_payments`: While passing raw card details to Chargebee Payments, if `fraud_session_id` is added, additional validation is performed to avoid fraudulent transactions.
        
        -   `fraud`: Fraud identification related information.
            -   `fraud_session_id`: Your Chargebee Payments fraud session ID required to perform anti-fraud validation.
    -   `bank_of_america`: While passing raw card details to Bank of America, your user's `device_session_id` can be added to perform additional validation and avoid fraudulent transactions.
        
        -   `fraud`: Fraud identification related information.
            -   `device_session_id`: Session ID associated with the user's device.
    -   `ecentric`: This parameter is used to verify and process payment method details in Ecentric. If the `merchant_id` parameter is included, Chargebee will vault it / perform a lookup and verification against this `merchant_id`, overriding the one configured in Chargebee. If tokens and processing occur in the same Merchant GUID, you can just skip this part.
        
        -   `merchant_id`: Merchant GUID where the card is vaulted or need to be vaulted.
    -   `ebanx`: While passing raw card details to EBANX, the user's `document` is required for some countries and `device_session_id` can be added to perform [additional validation](https://developer.ebanx.com/docs/payments/guides/features/device-fingerprint#device-fingerprint) and avoid fraudulent transactions.
        
        -   `payer`: User related information.
            -   `document`: Document is the user's identification number based on their country.
        -   `fraud`: Fraud identification related information.
            -   `device_session_id`: Session ID associated with the user's device

- `shipping_address` (optional, string)
  Parameters for shipping\_address
  - `first_name` (optional, string, max chars=150)
    The first name of the contact.
  - `last_name` (optional, string, max chars=150)
    The last name of the contact.
  - `email` (optional, string, max chars=70)
    The email address.
  - `company` (optional, string, max chars=250)
    The company name.
  - `phone` (optional, string, max chars=50)
    The phone number.
  - `line1` (optional, string, max chars=150)
    Address line 1
  - `line2` (optional, string, max chars=150)
    Address line 2
  - `line3` (optional, string, max chars=150)
    Address line 3
  - `city` (optional, string, max chars=50)
    The name of the city.
  - `state_code` (optional, string, max chars=50)
    The [ISO 3166-2 state/province code](https://www.iso.org/obp/ui/#search/code) without the country prefix. Currently supported for USA, Canada and India. For instance, for Arizona (USA), set `state_code` as `AZ` (not `US-AZ` ). For Tamil Nadu (India), set as `TN` (not `IN-TN` ). For British Columbia (Canada), set as `BC` (not `CA-BC` ).
  - `state` (optional, string, max chars=50)
    The state/province name. Is set by Chargebee automatically for US, Canada and India If `state_code` is provided.
  - `zip` (optional, string, max chars=20)
    Zip or postal code. The number of characters is validated according to the rules [specified here](https://chromium-i18n.appspot.com/ssl-address) .
  - `country` (optional, string, max chars=50)
    The billing address country of the customer. Must be one of [ISO 3166 alpha-2 country code](https://www.iso.org/iso-3166-country-codes.html) .
    
    **Note**: If you enter an invalid country code, the system will return an error.
    
    **Brexit**
    
    If you have enabled [EU VAT](https://www.chargebee.com/docs/eu-vat.html) in 2021 or later, or have [manually enable](https://www.chargebee.com/docs/brexit.html#what-needs-to-be-done-in-chargebee) the Brexit configuration, then `XI` (the code for **United Kingdom - Northern Ireland**) is available as an option.
  - `validation_status` (optional, enumerated string, default=not_validated)
    The address verification status.
    Possible enum values:
      - `not_validated`
        Address is not yet validated.
      - `valid`
        Address was validated successfully.
      - `partially_valid`
        The address is valid for taxability but has not been validated for shipping.
      - `invalid`
        Address is invalid.

- `subscription` (optional, string)
  Parameters for subscription
  - `plan_id` (required, string, max chars=100)
    Identifier of the plan for this subscription
  - `plan_quantity` (optional, integer, default=1, min=1)
    Plan quantity for this subscription
  - `plan_quantity_in_decimal` (optional, string, max chars=33)
    Plan Quantity for this subscription in Multi Decimal

- `addons` (optional, array)
  Parameters for addons
  - `id` (optional, string, max chars=100)
    Identifier of the addon. Multiple addons can be passed.
  - `quantity` (optional, integer)
    Quantity of the addon. Applicable for addons with `pricing_model` other than `flat_fee` .
  - `quantity_in_decimal` (optional, string, max chars=33)
    The decimal representation of the quantity of the addon. Returned for quantity-based plans when [multi-decimal pricing](/docs/api/v2/pcv-1/currencies) is enabled.

## Returns

- `gift` (Gift object)
  Resource object representing gift

- `subscription` (Subscription object)
  Resource object representing subscription

- `invoice` (Invoice object)
  Resource object representing invoice
